5887N/A#!/bin/ksh -p
5887N/A#
5887N/A# Copyright (c) 2008, 2011, Oracle and/or its affiliates. All rights reserved.
5887N/A#
5887N/A# Permission is hereby granted, free of charge, to any person obtaining a
5887N/A# copy of this software and associated documentation files (the
5887N/A# "Software"), to deal in the Software without restriction, including
5887N/A# without limitation the rights to use, copy, modify, merge, publish,
5887N/A# distribute, and/or sell copies of the Software, and to permit persons
5887N/A# to whom the Software is furnished to do so, provided that the above
5887N/A# copyright notice(s) and this permission notice appear in all copies of
5887N/A# the Software and that both the above copyright notice(s) and this
5887N/A# permission notice appear in supporting documentation.
5887N/A#
5887N/A# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
5887N/A# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
5887N/A# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT
5887N/A# OF THIRD PARTY RIGHTS. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR
5887N/A# HOLDERS INCLUDED IN THIS NOTICE BE LIABLE FOR ANY CLAIM, OR ANY SPECIAL
5887N/A# INDIRECT OR CONSEQUENTIAL DAMAGES, OR ANY DAMAGES WHATSOEVER RESULTING
5887N/A# FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
5887N/A# NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
5887N/A# WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
5887N/A#
5887N/A# Except as contained in this notice, the name of a copyright holder
5887N/A# shall not be used in advertising or otherwise to promote the sale, use
5887N/A# or other dealings in this Software without prior written authorization
5887N/A# of the copyright holder.
5887N/A#
5887N/A###########################################################################
5887N/A#
5887N/APATH=/usr/bin:/usr/sbin
5887N/A
5887N/A. /lib/svc/share/smf_include.sh
5887N/A
5887N/AUSAGE="Usage: $0 { start | refresh }"
5887N/AFIND_NEWER=/usr/share/desktop-cache/find_newer
5887N/A
5887N/Aif [ $# -ne 1 ] ; then
5887N/A echo $USAGE
5887N/A exit 2
5887N/Afi
5887N/A
5887N/A#
5887N/A# IF the mime cache exist then :
5887N/A# get the list of mime type files newer than the cache file
5887N/A# ELSE
5887N/A# make list greater than zero to generate a cache
5887N/A#
5887N/A# generate the cache
5887N/A#
5887N/A
5887N/AMIMEFILE="/usr/share/applications/mimeinfo.cache"
5887N/AMIMEDIR="/usr/share/applications"
5887N/A
5887N/Astart_desktop_mime_cache () {
5887N/A
5887N/Atest -w $MIMEDIR || {
5887N/A echo "$MIMEDIR is not writable, skipping."
5887N/A return
5887N/A}
5887N/A
5887N/Aif [ -a $MIMEFILE ]; then
5887N/A RESULT=`${FIND_NEWER} -f -c -m \
5887N/A --newer $MIMEFILE \
5887N/A /usr/share/applications 2>/dev/null`
5887N/Aelse
5887N/A RESULT="no cache found"
5887N/Afi
5887N/A
5887N/Aif [ -n "$RESULT" ]; then
5887N/A test -x /usr/bin/update-desktop-database || {
5887N/A echo "update-desktop-database not installed"
5887N/A return
5887N/A }
5887N/A echo "updating desktop file cache"
5887N/A /usr/bin/update-desktop-database -q
5887N/A if [ $? -ne 0 ]; then
5887N/A echo "update-mime-database exited with an error while generating the desktop file cache $MIMEFILE"
5887N/A exit $SMF_EXIT_ERR_FATAL
5887N/A else
5887N/A echo "desktop file cache $MIMEFILE generated"
5887N/A fi
5887N/Afi
5887N/A}
5887N/A
5887N/Arefresh_desktop_mime_cache () {
5887N/A
5887N/Atest -w $MIMEDIR || {
5887N/A echo "$MIMEDIR is not writable, skipping."
5887N/A return
5887N/A}
5887N/A
5887N/Aif [ -a $MIMEFILE ]; then
5887N/A RESULT=`/usr/bin/find /usr/share/applications ! -type d -follow 2>/dev/null`
5887N/Aelse
5887N/A RESULT="no cache found"
5887N/Afi
5887N/A
5887N/Aif [ -n "$RESULT" ]; then
5887N/A test -x /usr/bin/update-desktop-database || {
5887N/A echo "update-desktop-database not installed"
5887N/A return
5887N/A }
5887N/A echo "updating desktop file cache"
5887N/A /usr/bin/update-desktop-database -q
5887N/A if [ $? -ne 0 ]; then
5887N/A echo "update-mime-database exited with an error while generating the desktop file cache $MIMEFILE"
5887N/A exit $SMF_EXIT_ERR_FATAL
5887N/A else
5887N/A echo "desktop file cache $MIMEFILE generated"
5887N/A fi
5887N/Afi
5887N/A}
5887N/A
5887N/AMETHOD="$1"
5887N/A
5887N/Acase "$METHOD" in
5887N/A 'start')
5887N/A # Continue with rest of script
5887N/A ;;
5887N/A 'refresh')
5887N/A ;;
5887N/A -*)
5887N/A echo $USAGE
5887N/A exit 2
5887N/A ;;
5887N/A *)
5887N/A echo "Invalid method $METHOD"
5887N/A exit 2
5887N/A ;;
5887N/Aesac
5887N/A
5887N/A${METHOD}_desktop_mime_cache
5887N/A
5887N/Aexit $SMF_EXIT_OK